# hello-world

Simple "hello world"-style template programs. These will get you started writing programs in various languages.

Inspired by [Rosetta Code](http://rosettacode.org/wiki/Hello_world/Text)

See also [Rosetta Code for hello world web server](https://rosettacode.org/wiki/Hello_world/Web_server)



## A Partial List of Interesting Languages

A List of Languages:
* c
* c++
* c++ with boost (?)
* java
* octave
* python
* awk
* bash
* fortran
* go
* haskell
* lisp
* perl
* php
* ruby



## List of Programs 

### List of Programs Implemented for All Languages

Hello World:
* Your basic hello world program, prints something and exits.

What time is it:
* Prints the date as YYYY-MM-DD
* Prints the time as HH:MM:SS
* Shows how to get dates and times in the language, and format them for a standard output.

99 Bottles:
* Prints the lyrics to "99 Bottles of Beer on the Wall"
* Shows looping in the language.

Factorial:
* Implements the factorial function: `4! = 4*3*2*1`
* Uses iterative and recursive versions

HTTP Get:
* Implements accessing an HTTP resource using get
* [Link](http://rosettacode.org/wiki/HTTP)

HTTP Server:
* Implements running an http server 
* [Link](https://rosettacode.org/wiki/Hello_world/Web_server)

Calculus: Simpson's Rule for Integration
* Implements composite Simpson's Rule to integrate a function over an interval `[a,b]` using `n` approximating points

N Queens:
* Solve the N queens problem using integer arrays, with minimal object-oriented fluff.


### Programs In Progress

HTTP Post:
* Access an API using POST request

Algebra: Log and Trig Tables
* Print out logarithm and trigonometric tables
* Exercises trigonometric functions, formatted print functionality, loops

Calculus: Taylor Series Approximation of Sine Function
* Implements a Taylor Series to approximate a sine function

Calculus: Newton's Method
* Implements Newton's Method to compute the roots of an arbitrary function f(x)



### Programs To Implement

Arrays:
* Use a native built-in data type to store a 1D array of data

Matrix inversion:
* Gauss-Jordan elimination or back-substitution algorithm

Vector products:
* Given three three-dimensional vectors, compute dot/cross product, scalar/vector triple products
* http://rosettacode.org/wiki/Vector_products

Time a function:
* Time a function.
* http://rosettacode.org/wiki/Time_a_function

Calculus:
* Compute the numerical derivative of a function
* Compute the numerical integral of a function
* Integrate a differential equation

