# Awk

## Hello World

Prints hello world. Run like this:

```
$ awk -f hello_world.awk

Hello world!
```

## What Time Is It?

Prints the current date and time using built-in awk functions (strftime).

```
$ awk -f what_time_is_it.awk
```

## 99 Bottles

Prints the lyrics to the 99 Bottles of Beer on the Wall song:

```
$ awk -f 99bottles.awk

The beersong:

99 bottles of beer on the wall,
99 bottles of beer.
Take one down, pass it around.
98 bottles of beer on the wall.

98 bottles of beer on the wall,
98 bottles of beer.
Take one down, pass it around.
97 bottles of beer on the wall.

[...]
```

Runs with i = 99 bottles, but you can set it to seomthing more reasonable:

```
$ awk -v i=6 -f 99bottles.awk

The beersong:

6 bottles of beer on the wall,
6 bottles of beer.
Take one down, pass it around.
5 bottles of beer on the wall.

5 bottles of beer on the wall,
5 bottles of beer.
Take one down, pass it around.
4 bottles of beer on the wall.

[...]
```

## HTTP Get

This file will get a webpage using an HTTP GET request. Run the script like this:

```
$ awk -f http_get.awk

HTTP/1.1 200 OK
Server: nginx/1.9.3 (Ubuntu)
Date: Thu, 09 Mar 2017 19:45:26 GMT
Content-Type: text/html; charset=UTF-8
Connection: close
X-Content-Type-Options: nosniff
Content-language: en
X-UA-Compatible: IE=Edge
Vary: Accept-Encoding,Cookie
Expires: Thu, 01 Jan 1970 00:00:00 GMT
Cache-Control: private, must-revalidate, max-age=0
Last-Modified: Sun, 19 Feb 2017 21:59:32 GMT

<!DOCTYPE html>
<html lang="en" dir="ltr" class="client-nojs">
<head>
<meta charset="UTF-8" />
<title>charlesreid1</title>
```


## HTTP Post

This will send a POST request to a server. Specifically, this will call a URL and pass POST data with the request.

```
$ awk -f http_post.awk
```


## HTTP Server

Yes, you can abuse awk, a text manipulation scripting language, to run a web server. This utilizes networking capabilities deep within the bowels of awk.

The following script listens for a single request on port 8080. Once the user has visited localhost:8080, awk responds with an HTTP 200 OK code, and a "Hello World" page. 
Once the page has been returned, the script will die; the HTTP server is not persistent.

```
awk -f http_server.awk
```

## Factorial

Print the factorial of a number (12 by default). Edit to change it to your own number. To run:

```
$ awk -f factorial.awk

12! = 479001600
```

## Simpson's Rule

This integrates the function `sin(x)` from 0 to pi/2 (the result should be exactly 1) using Simpson's composite rule and a user-specified number of sample points.

```
awk -f simpsons_rule.awk
```







