# This program runs an HTTP server on port 8080.
# It will listen for a single connection, send an HTTP response, then die.
BEGIN {
    RS = ORS = "\r\n"

    # Reach into the bowels of awk
    HttpService = "/inet/tcp/8080/0/0"

    # Prepare the HTML response
    Hello = "<HTML><HEAD>" \
            "<TITLE>A Famous Greeting</TITLE></HEAD>" \
            "<BODY><H1>Hello, world</H1></BODY></HTML>"

    # Return the response to the HTTP service
    Len = length(Hello) + length(ORS)
    print "HTTP/1.0 200 OK"          |& HttpService
    print "Content-Length: " Len ORS |& HttpService
    print Hello                      |& HttpService

    # Now wait for a response
    while ((HttpService |& getline) > 0)
        continue;

    # Close it out
    close(HttpService)
}
