# C

## Hello world

To compile:

```
gcc hello_world.c -o hello.bin
```

To run:

```
./hello.bin
```

## What time is it 

To compile and run:

```
gcc what_time_is_it.c -o run.x
./run.x
```

## Factorial

This implements two factorial functions, one iterative and one recursive.

```
gcc factorial.c -o run.x
./run.x
```

## HTTP Get

Downloads an HTTP page. Requires libcurl. To compile and run:

```
gcc -lcurl http.c -o run.x
./run.x
```

## HTTP Server

Runs an HTTP server on port 8080. Uses sockets. Should not require any external linker flags. To compile and run:

```
gcc http_server.c -o run.x
./run.x
```

Now point the browser to <code>localhost:8080</code>.

## Simpson's Rule

Implements a composite Simpson's Rule on the interval [a,b] using the formula:

$$
\int_{a,b}{ f(x) dx } \approx \frac{h}{3} \left( f(a) + 2 \sum_{j} f(x_j) + 4 \sum_{i} f(x_i) + f(b) \right)
$$

where j indexes only the even index numbers of x_i, and i indexes only the odd index numbers of x_i.

This requires exercising some important scientific computing capabilities: the ability to assert things (n is even), pass functions as parameters, do for loops, and compute a sine function (and the value of pi).


