#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <err.h>
 
// Create the HTTP response in a string:
char response[] = "HTTP/1.1 200 OK\r\n"
"Content-Type: text/html; charset=UTF-8\r\n\r\n"
"<!DOCTYPE html><html><head><title>Allo Allo!</title></head>"
"<body><h1>Hello, world!</h1></body></html>\r\n";
 
int main()
{
	// This creates a web server by opening a socket and writing an HTTP response when clients connect. 

	// Prepare to open the socket 
    int one = 1, client;
    struct sockaddr_in svr_addr, cli_addr;
    socklen_t sin_len = sizeof(cli_addr);
 
	// Open the socket to the internet
    int sock = socket(AF_INET, SOCK_STREAM, 0);
    if (sock < 0) {
		err(1, "can't open socket");
	}
 
	// Make the socket re-usable 
    setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &one, sizeof(int));
 
	// Prepare to bind the socket to a network port
    int port = 8080;
    svr_addr.sin_family = AF_INET;
    svr_addr.sin_addr.s_addr = INADDR_ANY;
	svr_addr.sin_port = htons(port);
 
	// bind socket to network device
    if (bind(sock, (struct sockaddr *) &svr_addr, sizeof(svr_addr)) == -1) {
		close(sock);
		err(1, "Can't bind");
    }
 
	// Listen for connections
    listen(sock, 5);
    while (1) {

		// Accept incoming client connections from the socket
		client = accept(sock, (struct sockaddr *) &cli_addr, &sin_len);
		printf("Got connection\n");
 
		if (client == -1) {
			perror("Can't accept");
        	continue;
		}
 
		// Once we have a client, write the HTTP response and close the connection
		write(client, response, sizeof(response) - 1); /*-1:'\0'*/
		close(client);
    }
}
