#include<stdio.h>
#include<math.h>
#include<assert.h>
#define HALF_PI (1.570796326794897)

float f(float x)
{
    return sin(x);
}     

float simpsons_rule(float (*f)(float), float a, float b, int n) {
    assert(n%2==0);
    float s1=0, s2=0, sum=0;
    float h = (b-a) / n;
    for(int i = 1; i <= n; i++ ) {
        double x_i = a + i*h;
        if(i%2==0) { 
            s1 += f(x_i);
        } else {
            s2 += f(x_i);
        }
    }
    sum = (h/3)*(f(a) + f(b) + 2*s1 + 4*s2 );
    return sum;
}

int main()
{
    float x0 = 0;
    float x1 = HALF_PI;

    printf("Integrating sin(x) from 0 to HALF_PI = %0.4f \n", simpsons_rule(f,x0,x1,100) );
}
