package main
 
import (
    "fmt"
    "math/big"
)
 
func main() {
    //fmt.Println(ifactorial(800))
    fmt.Println(rfactorial(big.NewInt(800)))
}

// Recursive factorial
func rfactorial(n *big.Int) *big.Int {
	// See https://golang.org/pkg/math/big/

	// Initialize a bigInt with the value of 1
	one := big.NewInt(1)

	if n.Cmp(one) > 0 {
		// Recursive case
		nm1 := big.NewInt(0)
		nm1.Sub(n,one)
		return n.Mul(n, rfactorial(nm1) )
	} else {
		// Base case
		return one
	}
}
 
// Iterative factorial
func ifactorial(n int64) *big.Int {
    if n < 0 {
        return nil
    }
	
	// r starts as 1
    r := big.NewInt(1)

	// f is an empty big integer
    var f big.Int

    for i := int64(2); i <= n; i++ {
        r.Mul(r, f.SetInt64(i))
    }
    return r
}
