/**
 * Image Rotation.
 *
 * Programming puzzle: how do you rotate an NxN image (stored in an array) by 90 degrees, in-place? 
 */
import java.util.*;

public class RotateImage {
    public static void main(String[] args) { 
        Image z = new Image(5);
        z.rotateCW();
    }
}

class Image {
    public int[][] img;
    public int n;
    public Image(int n) { 
        this.n = n;
        Random r = new Random();
        img = new int[n][n];
        for(int i=0; i<n; i++) {
            for(int j=0; j<n; j++) { 
                img[i][j] = r.nextInt(1000);
            }
        }
    }
    public void rotateCW() { 
        System.out.println("Before:");
        this.print();
        int rowmax = (int)(Math.ceil(n/2.0));
        int colmax = (int)(Math.floor(n/2.0));
        for(int i=0; i<rowmax; i++) { 
            for(int j=0; j<colmax; j++) {
                int x1 = i,       y1 = j;
                int x2 = y1,      y2 = n-x1-1;
                int x3 = n-x1-1,  y3 = n-y1-1;
                int x4 = y3,      y4 = n-x3-1;

                int temp;
                temp        = img[x1][y1];
                img[x1][y1] = img[x4][y4];
                img[x4][y4] = img[x3][y3];
                img[x3][y3] = img[x2][y2];
                img[x2][y2] = temp;
            }
        }
        System.out.println("After:");
        this.print();
    }
    public void rotateCCW() { 
    }
    public void print() {
        for(int i=0; i<this.n; i++) {
            System.out.println(Arrays.toString(this.img[i]));
        }
        System.out.println();
    }

    public static int[] rot(int n, int x, int y) {
        int[] result = {y, n - (x-1)};
        return result;
    }
}
