import java.util.*;

public class Chapter3 { 
    public static void main(String[] args) { 
        System.out.println();

        // Problem 1
        // a) Find integers x and y such that 17x + 101y = 1
        int[] xy = new int[2];
        ModArithmetic.extendedEuclidian(xy, 17, 101);
        System.out.println("Problem 1a:");
        System.out.println("17x + 101y = 1");
        System.out.println("x = "+xy[0]);
        System.out.println("y = "+xy[1]);
        System.out.println("Check: 17 * "+xy[0]+" + 101 * "+xy[1]+" = "+(17*xy[0]+101*xy[1]) );
        System.out.println();

        // b) Find 17^-1 (mod 101)
        int inv = ModArithmetic.inverseMod(17,101);
        System.out.println("Problem 1b:");
        System.out.println("17^{-1} = "+inv+" (mod 101)");
        System.out.println("Check: 17 * "+inv+" = "+(17*inv)+" (mod 101) = "+(17*inv)%101+" (mod 101)");
        System.out.println();



        // Problem 2
        // a) Solve 7d = 1 (mod 30)
        int inv7 = ModArithmetic.inverseMod(7,30);
        System.out.println("Problem 2a:");
        System.out.println("Solve 7d = 1 (mod 30)");
        System.out.println("d = "+inv7);
        System.out.println("Check: 7 * "+inv7+" = "+(7*inv7)+" (mod 30) = "+(7*inv7)%30+" (mod 30)");
        System.out.println();

        // b) Suppose you encode a message as a number m mod 31:
        //      m = 12
        int m = 12;
        int encrypted = ModArithmetic.exponentMod(m,7,31);
        int decrypted = ModArithmetic.exponentMod(encrypted,inv7,31);
        System.out.println("Problem 2b:");
        System.out.println("Testing encryption scheme.");
        System.out.println("Message: "+m);
        System.out.println("Encrypted Message: "+m+"^"+7+" (mod 31) = "+encrypted+" (mod 31)");
        System.out.println("Decrypted Message: "+encrypted+"^"+inv7+" (mod 31) = "+decrypted+" (mod 31)");
        System.out.println("For (mod p), exponents are (mod p-1), so invert 7 by multiplying by 1/7 mod 30 (from part a)");
        System.out.println();



        // Problem 3
        // a) Find all solutions of 12x = 28 (mod 236)
        // b) Find all solutions of 12x = 30 (mod 236)
        ArrayList<Integer> result;

        System.out.println("Problem 3a:");
        System.out.println("Find solutions to 12x = 28 (mod 236).");
        try { 
            result = ModArithmetic.solve(12,28,236);
            System.out.println(result);
        } catch (RuntimeException e) {
            System.out.println("No inverse exists.");
        }
        // TODO: check
        System.out.println();

        System.out.println("Problem 3b:");
        System.out.println("Find solutions to 12x = 30 (mod 236).");
        try { 
            result = ModArithmetic.solve(12,30,236);
            System.out.println(result);
        } catch (RuntimeException e) {
            System.out.println("No inverse exists.");
        }
        // TODO: check
        System.out.println();







        // Problem 5 gcd
        int gcd = ModArithmetic.gcd(4883, 4369);
        System.out.println("Problem 5a:");
        System.out.println("Compute gcd(4883, 4369)");
        System.out.println( gcd );
        // TODO: check
        System.out.println();

        ArrayList<Integer> primes;
        System.out.println("Problem 5b:");
        System.out.println("Factor 4883 and 4369 into products of primes.");
        int n1 = 4883;
        int n2 = 4369;
        System.out.println("4883:");
        ArrayList<Integer> results1 = ModArithmetic.bootstrapFactorization(n1,gcd);
        System.out.println(results1);
        System.out.println("4369:");
        ArrayList<Integer> results2 = ModArithmetic.bootstrapFactorization(n2,gcd);
        System.out.println(results2);
        System.out.println();

        // Problem 6 Fibonacci gcds
        // Compute gcd(F_n, F_{n-1}) for all n>=1
        int n = 25;
        ArrayList<Integer> fib = ModArithmetic.fibonacci(n);
        System.out.println("Problem 6:");
        System.out.println("Compute gcd(F_{n}, F_{n-1}) for all n>=1.");
        for( int i = 1; i < fib.size(); i++ ) {
            int g = ModArithmetic.gcd( fib.get(i), fib.get(i-1) );
            System.out.println("The gcd of Fibonacci numbers F_"+(i)+" and F_"+(i-1)+" is "+g);
        }
        System.out.println();

    }
}
