#!/bin/sh
#
# Profile the N queens problem using Java Iteractive Profiler
# http://jiprof.sourceforge.net/
# 
# Also see http://charlesreid1.com/wiki/Java/Profiling
#
# Download source and look for profile/profile.jar

export PATH2JIP="${HOME}/Downloads/jip-src-1.2"

for N in 14
do

    echo "**************************************"
    echo "Profiling $N queens problem with Java JIP..."
    
    # Update N
    /usr/local/bin/sed -i "s/SIZE = [0-9]\{1,\}/SIZE = ${N}/g" NQueens.java
    
    # Compile
    javac NQueens.java
    
    java -javaagent:${PATH2JIP}/profile/profile.jar NQueens
    
    mv profile.txt profile_jip_${N}queens.out
    tail -n30 profile_${N}queens.out

done

