# Perl

## Hello world

```
perl hello_world.pl
```

Super simple script that just prints hello world.

## Hello file

```
perl hello_file.pl
```

This is a simple hello world program, but for writing output to a file.

## 99 Bottles

```
perl 99bottles.pl
```

99 bottles is a simple and repetitive task, but is a little more complicated than hello world.
This uses a variable storing one verse of the 99 bottles song, then passes it through a find-and-replace operation that replaces all digits `(\d+)` with their own value minus 1.
It then tries to replace any "1 bottles" with "1 bottle", which only happens if we've gotten all the way down to 1.
It then tries to replace any "0 bottles" with "No bottles", and if this replacement happens, it's used as a flag to signal that we're finished.
If we are not finished, it repeats the entire block.

## Factorial

```
perl fact.pl 
```

This file contains three factorial methods. 
The first function uses a for loop and an accumulator. 
The second function uses an in-line completion shorthand, similar to Python list comprehensions.
The last function is a recursive function.

## What Time Is It

```
perl what_time_is_it.pl
```

This is a script to illustrate the use of basic time libraries and time functionality in perl. This is as easy as using strftime.

## HTTP Server

```
perl http_server.pl
```

This script shows how to use the Sockets library in Perl to open a socket and connect it with an open port.
This allows incoming connections to pass through the port and into the socket.
Once clients connect, we send them a nice page.

## 8 Queens

Implementing backtracking in Perl to solve the 8 Queens problem and count the number of solutions.

This utilizes arrays to keep track of pieces placed on the chessboard, obviating the need for a more complicated 2D array approach.

This is generally how you best utilize Perl: re-work your algorithm to utilize Perl's data structures. Why? Because Perl's data structures are blazing fast, 
and if you just use Perl's built-in memory management and array iterators, you don't have to bother with clever optimizations or hand-tuned funrolls
or contorting your algorithm to try and out-C Perl.

You just use the structures provided.

That's exactly what this 8 queens method does.



























