#!/bin/sh
#
# Profile the N queens problem using Devel::NYTProf
#
# Install using cpanm:
# $ cpanm Devel::NYTProf
#

for N in 8 9 10 11 12
do

    echo "**************************************" 
    echo "Profiling $N queens problem with Perl..."
    
    # Update N
    /usr/local/bin/sed -i "s/board_size = [0-9]\{1,\};/board_size = ${N};/g" nqueens.pl
    
    echo "Running..."
    /usr/local/bin/perl -d:NYTProf nqueens.pl
    echo "Done."
    
    # CSV contains interesting info
    ${HOME}/perl5/bin/nytprofcsv nytprof.out 

    ## More information... 
    #${HOME}/perl5/bin/nytprofcg nytprof.out 
    #${HOME}/perl5/bin/nytprofhtml nytprof.out 

    mv nytprof nytprof${N}

done

