# Python

Interpreted language, no need to compile.

## Hello World

To run, use Python binary:

```
python hello_world.py
```

## What time is it

```
python what_time_is_it.py
```

## 99 bottles

Yup:

```
python 99bottles_variation.py
```

## Factorial

Three ways to compute a factorial: 
* Using math library
* Using loop (brute force/itrative approach)
* Using recursion

```
python factorial.py
```

## HTTP Get

Script showing how to grab the contents of a Wikipedia page.

```
$ python http_get.py
Getting Wikipedia page on the Babbage Engine...
200 OK
Obtained 127451 lines of HTML
```

## HTTP Server

```
$ cat index.html
<h2>Goodbye world!</h2>

$ python simple_http_server.py 8080

[now point browser to localhost:8080]
```

## Design Patterns

More on design patterns in Python: 
* [github link](https://github.com/faif/python-patterns)
* [blog link](http://ginstrom.com/scribbles/2007/10/08/design-patterns-python-style)

### Iterable

anything iterable over anything that is, uh, iterable. For example, you can have an iterable that returns word-numbers like "one" "two" "three" and so on.
The technique is to use a generator (yield). If you have a maximum number of iterable items, then you can use a zip, to take the smaller of angee(n) and range(len(iterables))

### Decorator

Nice way to wrap functionality with other functionality. For example, you can create a timing decorator, and apply it to different functions to force them to be timed each time.

### Factory

(NOT FINISHED)

Factory methods control/wrap objects and the object-creation process. 
They usually take care of the details of object crreation, storage, and retrieval. 
For example, the scalar equation factory is used to generate new equations with given properties.
IF you need the equation for a variable, you no longer need the equation object, you just need the factory and the equation label.
Then you say, getEquationByLabel("mylabel")

### Singleton

(NOT FINISHED)

A singleton design pattern restricts a class to having only a single instance. 
Factory is usually a singleton (or a function).
When you construct the class, it creates one instance of itself as a static variable (private).
When you ask for the class, it will either return the static instance, or (if it has not created it yet) will create it, then return it.


