import sys
import BaseHTTPServer
from SimpleHTTPServer import SimpleHTTPRequestHandler

"""
This script runs a simple and lightweight web server, which is used to serve up an HTML page.
The port number is 8000 by default, but can be specified by the user.

Usage:

    python webserver.py
    
    python webserver.py [port]

Test:

    Ensure index.html is in this directory, then point your browser to localhost:8000
"""

HandlerClass = SimpleHTTPRequestHandler
ServerClass  = BaseHTTPServer.HTTPServer
Protocol     = "HTTP/1.0"

if sys.argv[1:]:
    port = int(sys.argv[1])
else:
    port = 8000
server_address = ('', port)

HandlerClass.protocol_version = Protocol
httpd = ServerClass(server_address, HandlerClass)

sa = httpd.socket.getsockname()
print "Serving HTTP on", sa[0], "port", sa[1], "..."
httpd.serve_forever()

